/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2004  Yannick Le Goc (legoc@imag.fr)

/// http://artis.imag.fr/Members/Yannick.Legoc/X3D/

/// This library is free software; you can redistribute it and/or
/// modify it under the terms of the GNU Lesser General Public
/// License as published by the Free Software Foundation; either
/// version 2.1 of the License, or (at your option) any later version.

/// This library is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
/// Lesser General Public License for more details.

/// You should have received a copy of the GNU Lesser General Public
/// License along with this library; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
/*******************************************************************************
 *  generated by script                                                        *
 *******************************************************************************/

#ifndef X3DTK_X3DSCENEGRAPH_H
#define X3DTK_X3DSCENEGRAPH_H

//base
#include "../private/X3D_SceneGraphTypes.h"

//componentActors
#include "../private/X3D_CoreVisitor.h"
#include "../private/X3D_Geometry3DVisitor.h"
#include "../private/X3D_GroupingVisitor.h"
#include "../private/X3D_InterpolationVisitor.h"
#include "../private/X3D_LightingVisitor.h"
#include "../private/X3D_NavigationVisitor.h"
#include "../private/X3D_NetworkingVisitor.h"
#include "../private/X3D_NURBSVisitor.h"
#include "../private/X3D_RenderingVisitor.h"
#include "../private/X3D_ShapeVisitor.h"
#include "../private/X3D_TexturingVisitor.h"

//nodes

//Core
#include "../private/X3D_Scene.h"
#include "../private/X3D_X3DNode.h"
#include "../private/X3D_X3DObject.h"
#include "../private/X3D_X3DSensorNode.h"

//Geometry3D
#include "../private/X3D_Box.h"
#include "../private/X3D_Cone.h"
#include "../private/X3D_Cylinder.h"
#include "../private/X3D_IndexedFaceSet.h"
#include "../private/X3D_Sphere.h"

//Grouping
#include "../private/X3D_Group.h"
#include "../private/X3D_StaticGroup.h"
#include "../private/X3D_Switch.h"
#include "../private/X3D_Transform.h"
#include "../private/X3D_X3DBoundedObject.h"
#include "../private/X3D_X3DChildNode.h"
#include "../private/X3D_X3DGroupingNode.h"

//Interpolation
#include "../private/X3D_ColorInterpolator.h"
#include "../private/X3D_CoordinateInterpolator2D.h"
#include "../private/X3D_CoordinateInterpolator.h"
#include "../private/X3D_NormalInterpolator.h"
#include "../private/X3D_OrientationInterpolator.h"
#include "../private/X3D_PositionInterpolator2D.h"
#include "../private/X3D_PositionInterpolator.h"
#include "../private/X3D_ScalarInterpolator.h"
#include "../private/X3D_X3DInterpolatorNode.h"

//Lighting
#include "../private/X3D_DirectionalLight.h"
#include "../private/X3D_PointLight.h"
#include "../private/X3D_SpotLight.h"
#include "../private/X3D_X3DLightNode.h"

//Navigation
#include "../private/X3D_Collision.h"

//Networking
#include "../private/X3D_Inline.h"
#include "../private/X3D_X3DUrlObject.h"

//NURBS
#include "../private/X3D_Contour2D.h"
#include "../private/X3D_ContourPolyline2D.h"
#include "../private/X3D_CoordinateDeformer.h"
#include "../private/X3D_NurbsCurve2D.h"
#include "../private/X3D_NurbsCurve.h"
#include "../private/X3D_NurbsGroup.h"
#include "../private/X3D_NurbsPositionInterpolator.h"
#include "../private/X3D_NurbsSurface.h"
#include "../private/X3D_NurbsTextureSurface.h"
#include "../private/X3D_TrimmedSurface.h"
#include "../private/X3D_X3DParametricGeometryNode.h"

//Rendering
#include "../private/X3D_Color.h"
#include "../private/X3D_ColorRGBA.h"
#include "../private/X3D_Coordinate.h"
#include "../private/X3D_IndexedLineSet.h"
#include "../private/X3D_Normal.h"
#include "../private/X3D_PointSet.h"
#include "../private/X3D_TriangleFanSet.h"
#include "../private/X3D_TriangleSet.h"
#include "../private/X3D_TriangleStripSet.h"
#include "../private/X3D_X3DColorNode.h"
#include "../private/X3D_X3DComposedGeometryNode.h"
#include "../private/X3D_X3DCoordinateNode.h"
#include "../private/X3D_X3DGeometricPropertyNode.h"
#include "../private/X3D_X3DGeometryNode.h"
#include "../private/X3D_X3DNormalNode.h"

//Shape
#include "../private/X3D_Appearance.h"
#include "../private/X3D_FillProperties.h"
#include "../private/X3D_LineProperties.h"
#include "../private/X3D_Material.h"
#include "../private/X3D_Shape.h"
#include "../private/X3D_X3DAppearanceChildNode.h"
#include "../private/X3D_X3DAppearanceNode.h"
#include "../private/X3D_X3DMaterialNode.h"
#include "../private/X3D_X3DShapeNode.h"

//Texturing
#include "../private/X3D_ImageTexture.h"
#include "../private/X3D_TextureCoordinate.h"
#include "../private/X3D_TextureTransform.h"
#include "../private/X3D_X3DTexture2DNode.h"
#include "../private/X3D_X3DTextureCoordinateNode.h"
#include "../private/X3D_X3DTextureNode.h"
#include "../private/X3D_X3DTextureTransform2DNode.h"
#include "../private/X3D_X3DTextureTransformNode.h"

//componentCreators
#include "../private/X3D_CoreCreator.h"
#include "../private/X3D_Geometry3DCreator.h"
#include "../private/X3D_GroupingCreator.h"
#include "../private/X3D_InterpolationCreator.h"
#include "../private/X3D_LightingCreator.h"
#include "../private/X3D_NavigationCreator.h"
#include "../private/X3D_NetworkingCreator.h"
#include "../private/X3D_NURBSCreator.h"
#include "../private/X3D_RenderingCreator.h"
#include "../private/X3D_ShapeCreator.h"
#include "../private/X3D_TexturingCreator.h"
#include "../private/libXMLFileElement.h"
#include "../private/QFileElement.h"
#include "../private/X3D_Creator.h"
#include "../private/X3D_libXMLLoader.h"
#include "../private/X3D_Loader.h"
#include "../private/X3DLoader.h"
#include "../private/X3D_QLoader.h"
#include "../private/X3D_X3DComponentCreator.h"
#include "../private/X3D_X3DXmlLoader.h"
#include "../private/X3D_XercesLoader.h"
#include "../private/XercesFileElement.h"

#endif
