/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2004  Yannick Le Goc (legoc@imag.fr)

/// http://artis.imag.fr/Members/Yannick.Legoc/X3D/

/// This library is free software; you can redistribute it and/or
/// modify it under the terms of the GNU Lesser General Public
/// License as published by the Free Software Foundation; either
/// version 2.1 of the License, or (at your option) any later version.

/// This library is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
/// Lesser General Public License for more details.

/// You should have received a copy of the GNU Lesser General Public
/// License along with this library; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#ifndef X3DATTRIBUTERECORDER_H
#define X3DATTRIBUTERECORDER_H

namespace X3DTK {

class X3DAbstractNode;

class X3DAttributeRecorder
{
public:
  virtual void record(X3DAbstractNode *N) const = 0;
  virtual ~X3DAttributeRecorder() {};
};

template<class T, class V>
class AttributeRecorder : public X3DAttributeRecorder
{
public:
  AttributeRecorder(const SFString &name, V T:: *member, const V &init);

  void record(X3DAbstractNode *N) const;

private:
  SFString _name;
  V T:: *_member;
  V _init;
};

}

#include "X3DAttributeRecorder.inl"

#endif
