/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2004  Yannick Le Goc (legoc@imag.fr)

/// http://artis.imag.fr/Members/Yannick.Legoc/X3D/

/// This library is free software; you can redistribute it and/or
/// modify it under the terms of the GNU Lesser General Public
/// License as published by the Free Software Foundation; either
/// version 2.1 of the License, or (at your option) any later version.

/// This library is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
/// Lesser General Public License for more details.

/// You should have received a copy of the GNU Lesser General Public
/// License along with this library; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#ifndef X3DTK_X3D_WORLDCOORDTRANSLATORSHARECOREVISITOR_H
#define X3DTK_X3D_WORLDCOORDTRANSLATORSHARECOREVISITOR_H

#include "X3D_CoreVisitor.h"
#include "X3D_Scene.h"
#include "X3D_WorldCoordTranslatorStateVariables.h"

#include <map>
#include <list>

namespace X3DTK {
namespace X3D {

class X3DNode;
class Transform;

/*! \brief Class declared in <b><X3DTK/X3D/WorldCoordTranslator.h></b> providing a visitor
 *  for the Share traversal of the Core component for the X3D::WorldCoordTranslator processor.
 *
 *  \ingroup X3D
 */
 
class WorldCoordTranslatorShareCoreVisitor : public CoreVisitor
{
public:
  /// Constructor.
  WorldCoordTranslatorShareCoreVisitor();
  
  /// enters an X3DNode.
  static void enterX3DNode(X3DNode *N);

private:
  static std::map<Transform *, MFNode> getParentMap(X3DNode *N);  
  static std::list<Transform *> getTransformParent(X3DAbstractNode *N);
};

}
}

#endif
