/// This file is part of the X3DToolKit library
/// Copyright (C) 2002-2004  Yannick Le Goc (legoc@imag.fr)

/// http://artis.imag.fr/Members/Yannick.Legoc/X3D/

/// This library is free software; you can redistribute it and/or
/// modify it under the terms of the GNU Lesser General Public
/// License as published by the Free Software Foundation; either
/// version 2.1 of the License, or (at your option) any later version.

/// This library is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
/// Lesser General Public License for more details.

/// You should have received a copy of the GNU Lesser General Public
/// License along with this library; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#ifndef X3DTK_X3D_X3DTEXTURE2DNODE_H
#define X3DTK_X3D_X3DTEXTURE2DNODE_H

#include "X3D_X3DTextureNode.h"

namespace X3DTK {
namespace X3D {

/*! \brief Base class declared in <b><X3DTK/X3D/scenegraph.h></b>, part of the <a href="../../doc/X3DSpecs/Part01/components/texturing.html">
 *  Texturing component</a> defining an X3DTextureNode
 *  (<a href="../../doc/X3DSpecs/Part01/components/texturing.html#X3DTextureNode">
 *  documentation</a>).
 *
 *  \ingroup X3DSceneGraph
 */

class X3DTexture2DNode : public X3DTextureNode
{ 
public:  
  /// Constructor.
  X3DTexture2DNode();
  /// Destructor.
  virtual ~X3DTexture2DNode();
  
  /// Sets repeatS attribute.
  void setRepeatS(const SFBool &repeatS);
  /// Sets repeatT attribute.
  void setRepeatT(const SFBool &repeatT);
 
  /// Gets repeatS attribute.
  inline const SFBool &getRepeatS() {return _repeatS;};
  /// Gets repeatT attribute.
  inline const SFBool &getRepeatT() {return _repeatT;};

private:
  SFBool _repeatS;
  SFBool _repeatT;  
};

}
}

#endif
